/*
 * Created on Jul 9, 2003
 */
package analysis;

import util.Report;

/**
 * @author evans - translated from Selvin's sphere.cc
 */

public class CubeQuality extends MeasureQuality {
	protected double edge;

	public CubeQuality (double p_edge) {
		edge = p_edge;
	}
	
	static public void main (String args[]) {		 
		double edge = 0.0;
		
		try {
			edge = Double.valueOf(args[1]).doubleValue();
		} catch (NumberFormatException nfe) {
			Report.fatalError("Unable to parse double value: " + args[1]);
		}
		
		CubeQuality sq = new CubeQuality (edge);
		sq.analyze (args);
	}
	
	public double correctScore () {
		return edge * edge * edge;
	}
	
	public int scoreCell (String s, double x, double y, double z) {
		if ((Math.abs(x) <= edge)
			&& (Math.abs(y) <= edge)
			&& (Math.abs(z) <= edge)) {
				// System.err.println ("Good cell: " + x + ", " + y + ", " + z);
			return 1;
		} else {
			// System.err.println ("Bad cell: " + x + ", " + y + ", " + z);
			return -1;
		}
	}
}
