/*
 * Created on Jul 9, 2003
 */
package analysis;

import util.Report;

/**
 * @author evans - translated from Selvin's sphere.cc
 */

public class SphereQuality extends MeasureQuality {
	protected double radius;

	public SphereQuality (double p_radius) {
		radius = p_radius;
	}
	
	static public void main (String args[]) {		 
		double radius = 0.0;
		
		try {
			radius = Double.valueOf(args[1]).doubleValue();
		} catch (NumberFormatException nfe) {
			Report.fatalError("Unable to parse double value: " + args[1]);
		}
		
		SphereQuality sq = new SphereQuality (radius);
		sq.analyze (args);
	}
	
	public double correctScore () {
		return 4 * Math.PI * radius * radius * radius / 3;
	}
	
	public int scoreCell (String s, double x, double y, double z) {
		if ((Math.abs(x) < radius)
			&& (Math.abs(y) < radius)
			&& (Math.abs(z) < radius)) {
			return 1;
		} else {
			return -1;
		}
	}
}
