package cellmodels.simplecell;

import java.util.Vector;

import simulator.*;
import util.*;

public class SimpleCell extends Cell {
	public SimpleCell(int p_id,
					 SystemModel p_sys,
					 CellProgram p_cp,
					 Vector p_states,
					 int programNum) {
		super(p_id, p_sys, p_cp, p_states, programNum);
	}

	public FColor getColor() {
		if (hadSerious ()) {
			return new FColor (0.8, 0.8, 0.0);	
		} else {
			// Always use the last color
			//return getCellPrograms ()[getNumPrograms() - 1].getColor (this);
			// return getCellProgram().getColor (this);
			return getCellProgram().getColor(this);
		}
	}

	static class SimpleCellFactory extends CellFactory {
		public Cell create(
			int p_ID,
			SystemModel p_sys,
			CellProgram p_cp,
			String modelOptions,
			Vector states,
			int programNum) {
			Cell cell = new SimpleCell(p_ID, p_sys, p_cp, states, programNum);
			return cell;
		}
	}

	static {
		Simulation.cellModels.put(
			new String("cellmodels.simplecell.SimpleCell"),
			new SimpleCellFactory());
	}
}
