package cellmodels.simplecell;

import java.util.Vector;

import simulator.*;
public class SimpleCell2D extends SimpleCell {
	SimpleCell2D(
		int p_ID,
		SystemModel p_sys,
		CellProgram p_cp,
		Vector p_states,
		int programNum) {
		super(p_ID, p_sys, p_cp, p_states, programNum);
	}

	public int numDimensions () {
		return 2;
	}

	static class SimpleCellFactory extends CellFactory {
		public Cell create(
			int p_ID,
			SystemModel p_sys,
			CellProgram p_cp,
			String modelOptions,
			Vector p_states,
			int programNum) {
			Cell cell = new SimpleCell2D(p_ID, p_sys, p_cp, p_states, programNum);
			return cell;
		}
	}
	
	static {
		Simulation.cellModels.put(
			new String("cellmodels.simplecell.SimpleCell2D"),
			new SimpleCellFactory());
	}
}
