package gui;

import java.io.IOException;

import javax.swing.*;

import simulator.*;

public class GUI extends JApplet {
	static SimulationParameters params;

	public void init() {
	}

	public static void main(String[] args) throws IOException {
		params = new SimulationParameters ();
		params.parseParameters (args);
		
		if (params.parametersDefined()) {
			if (params.isBatchMode()) {
				if (params.getMaxSteps() == 0) {
					System.err.println(
						"Use -steps:<n> to specify number of steps to simulate in batch mode.");
				} else {
					Simulation sim = new Simulation(params);
					sim.runToCompletion();
					sim.finish();
				}
			} else {
				SimulationWindow mainWindow;
				
				if (params.isDisplay3D ()) {
					mainWindow = new SimulationWindow3D(params);	
				} else {
					mainWindow = new SimulationWindow2D(params);
				}
				
				mainWindow.setSize(750, 750);
				mainWindow.setVisible(true);
			}
		} else {
			System.err.println(
				"Usage: java gui.GUI [-batch] <simFile>"
					+ " <cellProgramFile>* [-stats:<statFile>]"
					+ " [-out:<outFile>] [-err:<errFile>]"
					+ " [-dna:<counterValue>]");
			System.exit(0);
		}
	}
}
