package gui;

import java.awt.event.*;
import javax.swing.*;
import util.*;

class MainMenu extends JMenuBar {
	SimulationWindow win;
	JMenuItem miFileNew = new JMenuItem("New");
	JMenuItem miFileExit = new JMenuItem("Exit");
	JCheckBoxMenuItem miOptionsShowStatistics =
		new JCheckBoxMenuItem("Show Statistics");
	JRadioButtonMenuItem miOptionsPLAFWindows =
		new JRadioButtonMenuItem("Windows");
	JMenuItem miSimulationStep = new JMenuItem("Step");
	JMenuItem miSimulationGoTo = new JMenuItem("Go to ...");
	JMenuItem miHelpAbout = new JMenuItem("About CellSim");
	JMenuItem miHelpClassHierarchy = new JMenuItem("Class Hierarchy");

	public MainMenu(SimulationWindow p_win) {
		win = p_win;
		MenuItemListener mil = new MenuItemListener();

		JMenu fileMenu = new JMenu("File");
		miFileNew.addActionListener(mil);
		miFileExit.addActionListener(mil);
		fileMenu.add(miFileNew);
		fileMenu.add(miFileExit);
		add(fileMenu);

		JMenu optionsMenu = new JMenu("Options");
		miOptionsShowStatistics.addActionListener(mil);
		add(optionsMenu);

		JMenu simulationMenu = new JMenu("Simulation");
		miSimulationStep.addActionListener(mil);
		miSimulationGoTo.addActionListener(mil);
		simulationMenu.add(miSimulationStep);
		simulationMenu.add(miSimulationGoTo);
		add(simulationMenu);

		JMenu helpMenu = new JMenu("Help");
		miHelpAbout.addActionListener(mil);
		miHelpClassHierarchy.addActionListener(mil);
		helpMenu.add(miHelpAbout);
		helpMenu.add(miHelpClassHierarchy);
		add(helpMenu);
	}

	class MenuItemListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			JMenuItem menuItem = (JMenuItem) e.getSource();
			if (menuItem == miFileExit) {
				System.exit(0);
			} else if (menuItem == miSimulationStep) {
				win.nextStep();
			} else if (menuItem == miSimulationGoTo) {
				win.advanceSteps();
			} else {
				Assert.badBranch ("Unhandled menu item");
			}
		}
	}
}
