package gui;

import util.*;
import javax.swing.table.*;
import simulator.StatsTable;

public class StatsTableModel extends AbstractTableModel {
	final String[] columnNames = { "Statistic", "Value" };
	private StatsTable laststats;

	public int getColumnCount() {
		return columnNames.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public int getRowCount() {
		if (laststats == null) {
			return 0;
		} else {
			return laststats.size();
		}
	}

	public Object getValueAt(int row, int col) {
		if (laststats == null) {
			return null;
		}

		if (col == 0) {
			return laststats.getKey(row);
		} else if (col == 1) {
			return new Long(laststats.getValue(row));
		} else {
			Assert.badBranch("Bad getValueAt: " + col);
			return null;
		}
	}

	public boolean isCellEditable(int row, int column) {
		return false;
	}

	public void updateStatistics(StatsTable stats) {
		int oldrows = getRowCount();
		laststats = stats;

		if (oldrows != stats.size()) {
			fireTableStructureChanged();
		} else {
			fireTableDataChanged();
		}
	}
}
