/*
 * Created on Jul 1, 2003
 */
package parsers.CPA;

import simulator.Bindings;
import util.Assert;
import util.Direction;
import util.DirectionSet;
import util.InvalidDirectionException;

/**
 * @author evans
 */
public class BindingDirection extends DirectionNode {
	private String var;
	private DirectionSet possibleDirs;

	public BindingDirection(String p_var) {
		var = p_var;
		possibleDirs = null;
	}

	public BindingDirection(String p_var, DirectionSet p_dirs) {
		var = p_var;
		possibleDirs = p_dirs;
	}

	public Direction eval(Bindings bindings) throws InvalidDirectionException {
		Object obj = bindings.lookup(var);
		if (obj == null) {
			util.Report.fatalError("Binding missing for: " + var);
		}

		Direction dir = (Direction) obj;

		if (possibleDirs != null && !possibleDirs.contains(dir)) {
			throw new InvalidDirectionException("Invalid binding: " + dir);
		}

		return dir;
	}

	public Bindings getVariables() {
		return new Bindings(var, Direction.ANY);
	}

	public String toString() {
		if (possibleDirs != null) {
			return "<dir: " + var + " in " + possibleDirs + ">";
		} else {
			return "<dir: " + var + ">";
		}
	}
}
