/*
 * Created on Jun 26, 2003
 */
package parsers.CPA;
import simulator.Bindings;
import simulator.Cell;
import util.Assert;
import util.FColor;
import util.InvalidDirectionException;

/**
 * @author David Evans
 */

public class CPAColor {
	private Term r, g, b;
	
	public CPAColor(Term p_r, Term p_g, Term p_b) {
		r = p_r;
		g = p_g;
		b = p_b;
	}
	
	public FColor eval (Cell c, Bindings bindings) {
		try {
			return new FColor (r.eval (c, bindings), g.eval (c, bindings), b.eval (c, bindings));
		} catch (InvalidDirectionException ide) {
			Assert.badBranch ();
			return null;		
		}
	}
	
	public String toString () {
		return "<color " + r.toString() + " " + g.toString() + " " + b.toString() + ">";
	}
	
	public String unparse() {
		return (r.toString() + " " + g.toString() + " " + b.toString()); 
	}
}
