/* Generated By:JavaCC: Do not edit this line. CPAParser.java */
package parsers.CPA;

import java.io.*;
import simulator.*;
import sysmodels.ChemicalDiffusion;
import util.*;
import java.util.Vector;

public class CPAParser extends Parser implements CPAParserConstants {
    public CellProgram getCellProgram() throws GenericParseException
    {
        try {
            CellProgram cp = parseInput ();
            /* System.out.println(cp.toString()); */
            return cp;
        } catch (ParseException x) {
            throw new GenericParseException(x.toString());
        }
    }

    public void init(String modelOptions)
    {
    }

    static class CPAParserFactory extends ParserFactory
    {
        public Parser create(BufferedReader inp, String modelOptions)
        {
            Parser cpaParser = new CPAParser(inp);
            cpaParser.init(modelOptions);
            return cpaParser;
        }
    }

    static
    {
        Simulation.parsers.put(new String("parsers.CPA.CPAParser"),new CPAParserFactory());
    }

  final public CPACellProgram parseInput() throws ParseException {
        CPACellProgram cp;
    cp = cellProgram();
    jj_consume_token(0);
                {if (true) return cp;}
    throw new Error("Missing return statement in function");
  }

// cellProgram ::= stateDescription+
  final public CPACellProgram cellProgram() throws ParseException {
        CPACellProgram cp = new CPACellProgram();
        CellState cs;
        ChemicalDescription cd;
    label_1:
    while (true) {
      if (jj_2_1(5)) {
        ;
      } else {
        break label_1;
      }
      cd = chemicalDescription();
                                       cp.addChemical(cd);
    }
    label_2:
    while (true) {
      if (jj_2_2(5)) {
        ;
      } else {
        break label_2;
      }
      cs = stateDescription();
                                    cp.addState(cs);
    }
                {if (true) return cp;}
    throw new Error("Missing return statement in function");
  }

// stateDescrption ::= STATE identifier 
//                     { [ COUNTERS counterList ] [ COLOR ] 
//                       [ EMITS emissionList] [ DIFFUSES emissionList ] 
//                       [ TRANSITIONS transitions } ]
  final public CellState stateDescription() throws ParseException {
        Token state;

        CPAColor sc = null;
        CellTransitionList ctl = null;
        CellSecretionNodeList cel = null;
        CellSecretionNodeList cfl = null;
        CellSecretionNodeList cdl = null;
        Vector counters = null;
    jj_consume_token(STATE);
    state = jj_consume_token(IDENTIFIER);
    jj_consume_token(LBRACE);
    if (jj_2_3(5)) {
      jj_consume_token(COUNTERS);
      counters = idList();
    } else {
      ;
    }
    if (jj_2_4(5)) {
      jj_consume_token(COLOR);
      sc = color();
    } else {
      ;
    }
    if (jj_2_5(5)) {
      jj_consume_token(EMITS);
      cel = emissionList();
    } else {
      ;
    }
    if (jj_2_6(5)) {
      jj_consume_token(FORWARDS);
      cfl = emissionList();
    } else {
      ;
    }
    if (jj_2_7(5)) {
      jj_consume_token(DIFFUSES);
      cdl = diffusionList();
    } else {
      ;
    }
    if (jj_2_8(5)) {
      jj_consume_token(TRANSITIONS);
      ctl = transitionList();
    } else {
      ;
    }
    jj_consume_token(RBRACE);
                {if (true) return new CellState(state.image,sc,cel,cfl,cdl,ctl,counters);}
    throw new Error("Missing return statement in function");
  }

// chemicalDescrption ::= CHEMICAL identifier 
//                     { [ COLOR ] 
//                       [ DIFFUSIONRATE rate ] ... }
  final public ChemicalDescription chemicalDescription() throws ParseException {
        Token chem;
        CPAColor sc = null;
        double spreadrate = -1.0;
        double evaporate = -1.0;
        double diffuserate = -1.0;
        double forcegain = 1.0;
        int diffusemodel = ChemicalDiffusion.LINEAR;
    jj_consume_token(CHEMICAL);
    chem = jj_consume_token(IDENTIFIER);
    jj_consume_token(LBRACE);
    if (jj_2_9(5)) {
      jj_consume_token(COLOR);
      sc = color();
    } else {
      ;
    }
    if (jj_2_10(5)) {
      jj_consume_token(DIFFUSEMODEL);
      diffusemodel = diffusionModel();
    } else {
      ;
    }
    if (jj_2_11(5)) {
      jj_consume_token(DIFFUSERATE);
      diffuserate = number();
    } else {
      ;
    }
    if (jj_2_12(5)) {
      jj_consume_token(SPREADRATE);
      spreadrate = number();
    } else {
      ;
    }
    if (jj_2_13(5)) {
      jj_consume_token(EVAPORATE);
      evaporate = number();
    } else {
      ;
    }
    if (jj_2_14(5)) {
      jj_consume_token(FORCEGAIN);
      forcegain = number();
    } else {
      ;
    }
    jj_consume_token(RBRACE);
                {if (true) return new ChemicalDescription (chem.image, sc, diffuserate, spreadrate, evaporate, forcegain, diffusemodel);}
    throw new Error("Missing return statement in function");
  }

  final public int diffusionModel() throws ParseException {
    if (jj_2_15(5)) {
      jj_consume_token(LINEAR);
                     {if (true) return ChemicalDiffusion.LINEAR;}
    } else if (jj_2_16(5)) {
      jj_consume_token(EXPONENTIAL);
                            {if (true) return ChemicalDiffusion.EXPONENTIAL;}
    } else if (jj_2_17(5)) {
      jj_consume_token(BELLSHAPE);
                          {if (true) return ChemicalDiffusion.BELLSHAPE;}
    } else if (jj_2_18(5)) {
      jj_consume_token(OSCILLATION);
                            {if (true) return ChemicalDiffusion.OSCILLATION;}
    } else if (jj_2_19(5)) {
      jj_consume_token(SUDDENRISE);
                           {if (true) return ChemicalDiffusion.SUDDENRISE;}
    } else if (jj_2_20(5)) {
      jj_consume_token(SUDDENDROP);
                           {if (true) return ChemicalDiffusion.SUDDENDROP;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Vector idList() throws ParseException {
        Vector res = new Vector ();
        Token id;
    id = jj_consume_token(IDENTIFIER);
                                        res.add (id.image);
    label_3:
    while (true) {
      if (jj_2_21(5)) {
        ;
      } else {
        break label_3;
      }
      jj_consume_token(COMMA);
      id = jj_consume_token(IDENTIFIER);
    }
                                                       res.add (id.image);
          {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public CPAColor color() throws ParseException {
        Term r, g ,b;
    if (jj_2_22(5)) {
      r = term();
      g = term();
      b = term();
                {if (true) return new CPAColor(r,g,b);}
    } else if (jj_2_23(5)) {
      jj_consume_token(RED);
                    {if (true) return new CPAColor (new LiteralTerm (1.0), new LiteralTerm (0.0), new LiteralTerm (0.0));}
    } else if (jj_2_24(5)) {
      jj_consume_token(GREEN);
                      {if (true) return new CPAColor (new LiteralTerm (0.0), new LiteralTerm (1.0), new LiteralTerm (0.0));}
    } else if (jj_2_25(5)) {
      jj_consume_token(BLUE);
                     {if (true) return new CPAColor (new LiteralTerm (0.0), new LiteralTerm (0.0), new LiteralTerm (1.0));}
    } else if (jj_2_26(5)) {
      jj_consume_token(WHITE);
                      {if (true) return new CPAColor (new LiteralTerm (1.0), new LiteralTerm (1.0), new LiteralTerm (1.0));}
    } else if (jj_2_27(5)) {
      jj_consume_token(BLACK);
                      {if (true) return new CPAColor (new LiteralTerm (0.0), new LiteralTerm (0.0), new LiteralTerm (0.0));}
    } else if (jj_2_28(5)) {
      jj_consume_token(YELLOW);
                       {if (true) return new CPAColor (new LiteralTerm (1.0), new LiteralTerm (1.0), new LiteralTerm (0.0));}
    } else if (jj_2_29(5)) {
      jj_consume_token(CYAN);
                     {if (true) return new CPAColor (new LiteralTerm (0.0), new LiteralTerm (1.0), new LiteralTerm (1.0));}
    } else if (jj_2_30(5)) {
      jj_consume_token(MAGENTA);
                        {if (true) return new CPAColor (new LiteralTerm (1.0), new LiteralTerm (1.0), new LiteralTerm (0.0));}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public CellSecretionNodeList emissionList() throws ParseException {
        CellSecretionNodeList cel = new CellSecretionNodeList();
        CellEmissionNode ce1, ce2;
    ce1 = emission();
                               cel.add(ce1);
    label_4:
    while (true) {
      if (jj_2_31(5)) {
        ;
      } else {
        break label_4;
      }
      jj_consume_token(COMMA);
      ce2 = emission();
                                       cel.add(ce2);
    }
                {if (true) return cel;}
    throw new Error("Missing return statement in function");
  }

  final public CellSecretionNodeList diffusionList() throws ParseException {
        CellSecretionNodeList cel = new CellSecretionNodeList();
        CellDiffusionNode ce1, ce2;
    ce1 = diffusion();
                                cel.add(ce1);
    label_5:
    while (true) {
      if (jj_2_32(5)) {
        ;
      } else {
        break label_5;
      }
      jj_consume_token(COMMA);
      ce2 = diffusion();
                                        cel.add(ce2);
    }
                {if (true) return cel;}
    throw new Error("Missing return statement in function");
  }

  final public CellDiffusionNode diffusion() throws ParseException {
        Token chem;
        double conc;
        double rate = 1.0;
    jj_consume_token(LPAREN);
    chem = jj_consume_token(IDENTIFIER);
    jj_consume_token(COMMA);
    conc = number();
    if (jj_2_33(5)) {
      jj_consume_token(COMMA);
      rate = number();
      jj_consume_token(RPAREN);
    } else {
      ;
    }
    jj_consume_token(RPAREN);
                        {if (true) return new CellDiffusionNode (chem.image, conc, rate);}
    throw new Error("Missing return statement in function");
  }

  final public CellEmissionNode emission() throws ParseException {
        Token chem;
        Term conc;
        DirectionNode direction = null;
    jj_consume_token(LPAREN);
    chem = jj_consume_token(IDENTIFIER);
    jj_consume_token(COMMA);
    conc = term();
    jj_consume_token(RPAREN);
    if (jj_2_34(5)) {
      direction = emissionDirection();
    } else {
      ;
    }
                        {if (true) return new CellEmissionNode (chem.image, conc, direction);}
    throw new Error("Missing return statement in function");
  }

  final public DirectionNode emissionDirection() throws ParseException {
    DirectionNode direction;
    jj_consume_token(IN);
    direction = direction();
            {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public CellTransitionList transitionList() throws ParseException {
        CellTransition ct;
        CellTransitionList ctl = new CellTransitionList();
    label_6:
    while (true) {
      ct = transition();
      jj_consume_token(SEMICOLON);
                                          ctl.add(ct);
      if (jj_2_35(5)) {
        ;
      } else {
        break label_6;
      }
    }
                {if (true) return ctl;}
    throw new Error("Missing return statement in function");
  }

  final public CellTransition transition() throws ParseException {
        ChemicalConditionList ccl = new ChemicalConditionList ();
        CellSecretionNodeList cel;
        CellTransition ct;
    if (jj_2_36(5)) {
      ccl = chemicalConditionList();
    } else {
      ;
    }
    jj_consume_token(TO);
    if (jj_2_37(5)) {
      ct = cellTransition(ccl);
    } else if (jj_2_38(5)) {
      jj_consume_token(DIE);
                      ct = new CellTransition(ccl);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_39(5)) {
      jj_consume_token(EMITS);
      cel = emissionList();
                                               ct.addCellEmissionList(cel);
    } else {
      ;
    }
    if (jj_2_40(5)) {
      jj_consume_token(STORES);
      cel = emissionList();
                                                ct.addCellStorageList(cel);
    } else {
      ;
    }
                ct.resolve ();
                {if (true) return ct;}
    throw new Error("Missing return statement in function");
  }

  final public CellTransition cellTransition(ChemicalConditionList ccl) throws ParseException {
        CellParameters cell1;
        CellParameters cell2 = null;
        DirectionNode direction = null;
    jj_consume_token(LPAREN);
    cell1 = cellParameters();
    if (jj_2_41(5)) {
      jj_consume_token(COMMA);
      cell2 = cellParameters();
    } else {
      ;
    }
    jj_consume_token(RPAREN);
    if (jj_2_42(5)) {
      direction = cellDivisionDirection();
    } else {
      ;
    }
                if (cell2 == null) {
                        {if (true) return new CellTransition (ccl, new CellStateChange (cell1));}
                } else {
                        {if (true) return new CellTransition (ccl, new CellDivision (cell1, cell2, direction));}
                }
    throw new Error("Missing return statement in function");
  }

  final public CellParameters cellParameters() throws ParseException {
        Token state;
        Bindings bindings = null;
    state = jj_consume_token(IDENTIFIER);
    if (jj_2_43(5)) {
      bindings = cellBindings();
    } else {
      ;
    }
                {if (true) return new CellParameters (state.image, bindings);}
    throw new Error("Missing return statement in function");
  }

  final public Bindings cellBindings() throws ParseException {
        Bindings bindings = new Bindings ();
        Binding binding;
    jj_consume_token(LSQUARE);
    binding = binding();
                                         bindings.addBinding (binding.getIdentifier (), binding.getTerm ());
    label_7:
    while (true) {
      if (jj_2_44(5)) {
        ;
      } else {
        break label_7;
      }
      jj_consume_token(COMMA);
      binding = binding();
                                                   bindings.addBinding (binding.getIdentifier (), binding.getTerm ());
    }
    jj_consume_token(RSQUARE);
                {if (true) return bindings;}
    throw new Error("Missing return statement in function");
  }

  final public Binding binding() throws ParseException {
        Token lvalue;
        Term t;
    lvalue = jj_consume_token(IDENTIFIER);
    jj_consume_token(COLON);
    t = term();
      {if (true) return new Binding (lvalue.image, t);}
    throw new Error("Missing return statement in function");
  }

  final public ChemicalConditionList chemicalConditionList() throws ParseException {
        ChemicalCondition cc1, cc2;
        ChemicalConditionList ccl = new ChemicalConditionList();
    cc1 = parenChemicalCondition();
                                             ccl.add(cc1);
    label_8:
    while (true) {
      if (jj_2_45(5)) {
        ;
      } else {
        break label_8;
      }
      jj_consume_token(AND);
      cc2 = parenChemicalCondition();
                                                   ccl.add(cc2);
    }
                {if (true) return ccl;}
    throw new Error("Missing return statement in function");
  }

  final public ChemicalCondition parenChemicalCondition() throws ParseException {
        ChemicalCondition cc;
    if (jj_2_46(2147483647)) {
      cc = chemicalCondition();
    } else if (jj_2_47(5)) {
      jj_consume_token(LPAREN);
      cc = parenChemicalCondition();
      jj_consume_token(RPAREN);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
           {if (true) return cc;}
    throw new Error("Missing return statement in function");
  }

  final public ChemicalCondition chemicalCondition() throws ParseException {
        Term chem1, chem2;
        Token compare;
        ChemicalCondition cc;
    chem1 = term();
    compare = compareOp();
    chem2 = term();
              cc = new ChemicalCondition (chem1, compare, chem2);
           {if (true) return cc;}
    throw new Error("Missing return statement in function");
  }

  final public DirectionNode chemConditionDirection() throws ParseException {
    DirectionNode direction;
    jj_consume_token(FROM);
    direction = direction();
            {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public DirectionNode direction() throws ParseException {
        DirectionNode direction;
        Direction basicdirection;
        Token id;
        DirectionSet dirset = null;
    if (jj_2_49(5)) {
      basicdirection = basicDirection();
                                                direction = new BasicDirection (basicdirection);
    } else if (jj_2_50(5)) {
      direction = derivedDirection();
    } else if (jj_2_51(5)) {
      id = jj_consume_token(IDENTIFIER);
      if (jj_2_48(5)) {
        jj_consume_token(IN);
        dirset = directionSet();
      } else {
        ;
      }
                                                                      direction = new BindingDirection (id.image, dirset);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
  {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public DirectionSet directionSet() throws ParseException {
        Direction dir;
        DirectionSet res = new DirectionSet ();
    jj_consume_token(LBRACE);
    dir = basicDirection();
                                             res.add(dir);
    label_9:
    while (true) {
      jj_consume_token(COMMA);
      dir = basicDirection();
                                                                                                 res.add(dir);
      if (jj_2_52(5)) {
        ;
      } else {
        break label_9;
      }
    }
    jj_consume_token(RBRACE);
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Direction basicDirection() throws ParseException {
    Direction direction;
    if (jj_2_53(5)) {
      jj_consume_token(XPLUS);
                  direction = Direction.XP;
    } else if (jj_2_54(5)) {
      jj_consume_token(XMINUS);
                     direction = Direction.XM;
    } else if (jj_2_55(5)) {
      jj_consume_token(YPLUS);
                     direction = Direction.YP;
    } else if (jj_2_56(5)) {
      jj_consume_token(YMINUS);
                     direction = Direction.YM;
    } else if (jj_2_57(5)) {
      jj_consume_token(ZPLUS);
                     direction = Direction.ZP;
    } else if (jj_2_58(5)) {
      jj_consume_token(ZMINUS);
                     direction = Direction.ZM;
    } else if (jj_2_59(5)) {
      jj_consume_token(ANY);
      jj_consume_token(DIRECTION);
                              direction = Direction.ANY;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public DerivedDirection derivedDirection() throws ParseException {
        DerivedDirection direction;
        DirectionNode dir;
    if (jj_2_60(5)) {
      jj_consume_token(OPPOSITE);
      jj_consume_token(LPAREN);
      dir = direction();
      jj_consume_token(RPAREN);
              direction = new DerivedDirection (DerivedDirection.OPPOSITE, dir);
    } else if (jj_2_61(5)) {
      jj_consume_token(PERPENDICULAR);
      jj_consume_token(LPAREN);
      dir = direction();
      jj_consume_token(RPAREN);
              direction = new DerivedDirection (DerivedDirection.PERPENDICULAR, dir);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public DirectionNode cellDivisionDirection() throws ParseException {
    DirectionNode direction;
    jj_consume_token(IN);
    direction = direction();
            {if (true) return direction;}
    throw new Error("Missing return statement in function");
  }

  final public Token compareOp() throws ParseException {
        Token op;
    if (jj_2_62(5)) {
      op = jj_consume_token(LT);
    } else if (jj_2_63(5)) {
      op = jj_consume_token(GT);
    } else if (jj_2_64(5)) {
      op = jj_consume_token(EQUALS);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
   {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public Token arithOp() throws ParseException {
    Token op;
    if (jj_2_65(5)) {
      op = jj_consume_token(PLUS);
    } else if (jj_2_66(5)) {
      op = jj_consume_token(MINUS);
    } else if (jj_2_67(5)) {
      op = jj_consume_token(TIMES);
    } else if (jj_2_68(5)) {
      op = jj_consume_token(DIVIDE);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public Term term() throws ParseException {
        Term t;
    if (jj_2_69(5)) {
      jj_consume_token(LPAREN);
      t = term();
      jj_consume_token(RPAREN);
    } else if (jj_2_70(5)) {
      t = goalTerm();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Term goalTerm() throws ParseException {
        Term t;
        Token minmax;
    if (jj_2_71(5)) {
      minmax = goalKind();
      jj_consume_token(LPAREN);
      t = term();
      jj_consume_token(RPAREN);
            {if (true) return new GoalTerm (minmax, t);}
    } else if (jj_2_72(5)) {
      t = arithTerm();
            {if (true) return t;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Token goalKind() throws ParseException {
        Token t;
    if (jj_2_73(5)) {
      t = jj_consume_token(MINIMIZE);
    } else if (jj_2_74(5)) {
      t = jj_consume_token(MAXIMIZE);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Term arithTerm() throws ParseException {
        Term t;
        Term t2 = null;
        Token arithop = null;
    t = primaryTerm();
    if (jj_2_75(5)) {
      arithop = arithOp();
      t2 = primaryTerm();
    } else {
      ;
    }
                if (arithop == null) { {if (true) return t;} }
                else { {if (true) return new OpTerm (t, arithop, t2);} }
    throw new Error("Missing return statement in function");
  }

  final public Term primaryTerm() throws ParseException {
        Term t;
        double constant;
        Token chemical;
        DirectionNode orient;
    if (jj_2_76(5)) {
      constant = number();
                                   t = new LiteralTerm (constant);
    } else if (jj_2_77(2147483647)) {
      t = chemicalTerm();
    } else if (jj_2_78(2147483647)) {
      orient = direction();
                                                              t = new DirectionTerm (orient);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Term chemicalTerm() throws ParseException {
        Token chemical;
        DirectionNode dir = null;
    chemical = jj_consume_token(IDENTIFIER);
    if (jj_2_79(5)) {
      dir = chemConditionDirection();
    } else {
      ;
    }
          {if (true) return new ChemicalTerm (chemical.image, dir);}
    throw new Error("Missing return statement in function");
  }

  final public double number() throws ParseException {
        Token num;
    if (jj_2_80(5)) {
      num = jj_consume_token(INTEGER_LITERAL);
                        try
                        {
                                int x = Integer.parseInt(num.image);
                                {if (true) return (double) x;}
                        }
                        catch (NumberFormatException ee)
                        {
                                {if (true) throw new ParseException();}
                        }
    } else if (jj_2_81(5)) {
      num = jj_consume_token(FLOATING_POINT_LITERAL);
                        try
                        {
                                double x = Double.parseDouble (num.image);
                                {if (true) return x;}
                        }
                        catch (NumberFormatException ee)
                        {
                                {if (true) throw new ParseException();}
                        }
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_37(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(36, xla); }
  }

  final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_38(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(37, xla); }
  }

  final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_39(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(38, xla); }
  }

  final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_40(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(39, xla); }
  }

  final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_41(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(40, xla); }
  }

  final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_42(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(41, xla); }
  }

  final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_43(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(42, xla); }
  }

  final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_44(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(43, xla); }
  }

  final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_45(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(44, xla); }
  }

  final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_46(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(45, xla); }
  }

  final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_47(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(46, xla); }
  }

  final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_48(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(47, xla); }
  }

  final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_49(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(48, xla); }
  }

  final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_50(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(49, xla); }
  }

  final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_51(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(50, xla); }
  }

  final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_52(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(51, xla); }
  }

  final private boolean jj_2_53(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_53(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(52, xla); }
  }

  final private boolean jj_2_54(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_54(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(53, xla); }
  }

  final private boolean jj_2_55(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_55(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(54, xla); }
  }

  final private boolean jj_2_56(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_56(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(55, xla); }
  }

  final private boolean jj_2_57(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_57(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(56, xla); }
  }

  final private boolean jj_2_58(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_58(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(57, xla); }
  }

  final private boolean jj_2_59(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_59(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(58, xla); }
  }

  final private boolean jj_2_60(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_60(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(59, xla); }
  }

  final private boolean jj_2_61(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_61(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(60, xla); }
  }

  final private boolean jj_2_62(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_62(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(61, xla); }
  }

  final private boolean jj_2_63(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_63(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(62, xla); }
  }

  final private boolean jj_2_64(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_64(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(63, xla); }
  }

  final private boolean jj_2_65(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_65(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(64, xla); }
  }

  final private boolean jj_2_66(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_66(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(65, xla); }
  }

  final private boolean jj_2_67(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_67(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(66, xla); }
  }

  final private boolean jj_2_68(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_68(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(67, xla); }
  }

  final private boolean jj_2_69(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_69(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(68, xla); }
  }

  final private boolean jj_2_70(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_70(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(69, xla); }
  }

  final private boolean jj_2_71(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_71(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(70, xla); }
  }

  final private boolean jj_2_72(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_72(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(71, xla); }
  }

  final private boolean jj_2_73(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_73(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(72, xla); }
  }

  final private boolean jj_2_74(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_74(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(73, xla); }
  }

  final private boolean jj_2_75(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_75(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(74, xla); }
  }

  final private boolean jj_2_76(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_76(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(75, xla); }
  }

  final private boolean jj_2_77(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_77(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(76, xla); }
  }

  final private boolean jj_2_78(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_78(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(77, xla); }
  }

  final private boolean jj_2_79(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_79(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(78, xla); }
  }

  final private boolean jj_2_80(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_80(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(79, xla); }
  }

  final private boolean jj_2_81(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_81(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(80, xla); }
  }

  final private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_49()) {
    jj_scanpos = xsp;
    if (jj_3_50()) {
    jj_scanpos = xsp;
    if (jj_3_51()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_18()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3_79() {
    if (jj_3R_42()) return true;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3_81() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_scan_token(FROM)) return true;
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_21()) return true;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_3R_21()) return true;
    return false;
  }

  final private boolean jj_3_46() {
    if (jj_3R_31()) return true;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_3R_19()) return true;
    if (jj_3R_44()) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_80()) {
    jj_scanpos = xsp;
    if (jj_3_81()) return true;
    }
    return false;
  }

  final private boolean jj_3_80() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_78() {
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3_77() {
    if (jj_3R_41()) return true;
    return false;
  }

  final private boolean jj_3_31() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  final private boolean jj_3_47() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_30()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_79()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_3R_31()) return true;
    return false;
  }

  final private boolean jj_3R_30() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3_47()) return true;
    }
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_3R_20()) return true;
    return false;
  }

  final private boolean jj_3_75() {
    if (jj_3R_39()) return true;
    if (jj_3R_40()) return true;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_3R_41()) return true;
    return false;
  }

  final private boolean jj_3_45() {
    if (jj_scan_token(AND)) return true;
    if (jj_3R_30()) return true;
    return false;
  }

  final private boolean jj_3_30() {
    if (jj_scan_token(MAGENTA)) return true;
    return false;
  }

  final private boolean jj_3_76() {
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3_29() {
    if (jj_scan_token(CYAN)) return true;
    return false;
  }

  final private boolean jj_3_28() {
    if (jj_scan_token(YELLOW)) return true;
    return false;
  }

  final private boolean jj_3_27() {
    if (jj_scan_token(BLACK)) return true;
    return false;
  }

  final private boolean jj_3_26() {
    if (jj_scan_token(WHITE)) return true;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_3R_30()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_45()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_25() {
    if (jj_scan_token(BLUE)) return true;
    return false;
  }

  final private boolean jj_3_24() {
    if (jj_scan_token(GREEN)) return true;
    return false;
  }

  final private boolean jj_3R_40() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_76()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_scan_token(RED)) return true;
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_3R_19()) return true;
    if (jj_3R_19()) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3_27()) {
    jj_scanpos = xsp;
    if (jj_3_28()) {
    jj_scanpos = xsp;
    if (jj_3_29()) {
    jj_scanpos = xsp;
    if (jj_3_30()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_3R_40()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_75()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_44() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_29()) return true;
    return false;
  }

  final private boolean jj_3_43() {
    if (jj_3R_28()) return true;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_21()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_74() {
    if (jj_scan_token(MAXIMIZE)) return true;
    return false;
  }

  final private boolean jj_3_73() {
    if (jj_scan_token(MINIMIZE)) return true;
    return false;
  }

  final private boolean jj_3R_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_73()) {
    jj_scanpos = xsp;
    if (jj_3_74()) return true;
    }
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(LSQUARE)) return true;
    if (jj_3R_29()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_44()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RSQUARE)) return true;
    return false;
  }

  final private boolean jj_3_20() {
    if (jj_scan_token(SUDDENDROP)) return true;
    return false;
  }

  final private boolean jj_3_72() {
    if (jj_3R_38()) return true;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_scan_token(SUDDENRISE)) return true;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(OSCILLATION)) return true;
    return false;
  }

  final private boolean jj_3R_36() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_71()) {
    jj_scanpos = xsp;
    if (jj_3_72()) return true;
    }
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_scan_token(BELLSHAPE)) return true;
    return false;
  }

  final private boolean jj_3_71() {
    if (jj_3R_37()) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_19()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_scan_token(EXPONENTIAL)) return true;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_scan_token(LINEAR)) return true;
    return false;
  }

  final private boolean jj_3R_17() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3_17()) {
    jj_scanpos = xsp;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3_20()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_43()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_42() {
    if (jj_3R_27()) return true;
    return false;
  }

  final private boolean jj_3_70() {
    if (jj_3R_36()) return true;
    return false;
  }

  final private boolean jj_3_69() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_19()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(DIFFUSEMODEL)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_scan_token(FORCEGAIN)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(COLOR)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  final private boolean jj_3_13() {
    if (jj_scan_token(EVAPORATE)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3R_19() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_69()) {
    jj_scanpos = xsp;
    if (jj_3_70()) return true;
    }
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(SPREADRATE)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_scan_token(DIFFUSERATE)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_scan_token(CHEMICAL)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_11()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_12()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_13()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_14()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_41() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_26()) return true;
    return false;
  }

  final private boolean jj_3_68() {
    if (jj_scan_token(DIVIDE)) return true;
    return false;
  }

  final private boolean jj_3_67() {
    if (jj_scan_token(TIMES)) return true;
    return false;
  }

  final private boolean jj_3_66() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_26()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_41()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    xsp = jj_scanpos;
    if (jj_3_42()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_65() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  final private boolean jj_3R_39() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_65()) {
    jj_scanpos = xsp;
    if (jj_3_66()) {
    jj_scanpos = xsp;
    if (jj_3_67()) {
    jj_scanpos = xsp;
    if (jj_3_68()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_52() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_33()) return true;
    return false;
  }

  final private boolean jj_3_40() {
    if (jj_scan_token(STORES)) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_39() {
    if (jj_scan_token(EMITS)) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_64() {
    if (jj_scan_token(EQUALS)) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(TRANSITIONS)) return true;
    if (jj_3R_16()) return true;
    return false;
  }

  final private boolean jj_3_63() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_scan_token(DIFFUSES)) return true;
    if (jj_3R_15()) return true;
    return false;
  }

  final private boolean jj_3_38() {
    if (jj_scan_token(DIE)) return true;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_scan_token(FORWARDS)) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_37() {
    if (jj_3R_25()) return true;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(EMITS)) return true;
    if (jj_3R_14()) return true;
    return false;
  }

  final private boolean jj_3_36() {
    if (jj_3R_24()) return true;
    return false;
  }

  final private boolean jj_3_62() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(COLOR)) return true;
    if (jj_3R_13()) return true;
    return false;
  }

  final private boolean jj_3R_44() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_62()) {
    jj_scanpos = xsp;
    if (jj_3_63()) {
    jj_scanpos = xsp;
    if (jj_3_64()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_23() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_36()) jj_scanpos = xsp;
    if (jj_scan_token(TO)) return true;
    xsp = jj_scanpos;
    if (jj_3_37()) {
    jj_scanpos = xsp;
    if (jj_3_38()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3_39()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_40()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(COUNTERS)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3R_11() {
    if (jj_scan_token(STATE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3_61() {
    if (jj_scan_token(PERPENDICULAR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_35()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3_35() {
    if (jj_3R_23()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_16() {
    Token xsp;
    if (jj_3_35()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_35()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_60() {
    if (jj_scan_token(OPPOSITE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_35()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_34() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_60()) {
    jj_scanpos = xsp;
    if (jj_3_61()) return true;
    }
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_11()) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_10()) return true;
    return false;
  }

  final private boolean jj_3_59() {
    if (jj_scan_token(ANY)) return true;
    if (jj_scan_token(DIRECTION)) return true;
    return false;
  }

  final private boolean jj_3_58() {
    if (jj_scan_token(ZMINUS)) return true;
    return false;
  }

  final private boolean jj_3_48() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_32()) return true;
    return false;
  }

  final private boolean jj_3_57() {
    if (jj_scan_token(ZPLUS)) return true;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3_56() {
    if (jj_scan_token(YMINUS)) return true;
    return false;
  }

  final private boolean jj_3_55() {
    if (jj_scan_token(YPLUS)) return true;
    return false;
  }

  final private boolean jj_3_54() {
    if (jj_scan_token(XMINUS)) return true;
    return false;
  }

  final private boolean jj_3_34() {
    if (jj_3R_22()) return true;
    return false;
  }

  final private boolean jj_3_53() {
    if (jj_scan_token(XPLUS)) return true;
    return false;
  }

  final private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_53()) {
    jj_scanpos = xsp;
    if (jj_3_54()) {
    jj_scanpos = xsp;
    if (jj_3_55()) {
    jj_scanpos = xsp;
    if (jj_3_56()) {
    jj_scanpos = xsp;
    if (jj_3_57()) {
    jj_scanpos = xsp;
    if (jj_3_58()) {
    jj_scanpos = xsp;
    if (jj_3_59()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_33()) return true;
    Token xsp;
    if (jj_3_52()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_52()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_51() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_48()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_50() {
    if (jj_3R_34()) return true;
    return false;
  }

  final private boolean jj_3_49() {
    if (jj_3R_33()) return true;
    return false;
  }

  public CPAParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[81];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public CPAParser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new CPAParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public CPAParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new CPAParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public CPAParser(CPAParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(CPAParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[83];
    for (int i = 0; i < 83; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 83; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 81; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
            case 52: jj_3_53(); break;
            case 53: jj_3_54(); break;
            case 54: jj_3_55(); break;
            case 55: jj_3_56(); break;
            case 56: jj_3_57(); break;
            case 57: jj_3_58(); break;
            case 58: jj_3_59(); break;
            case 59: jj_3_60(); break;
            case 60: jj_3_61(); break;
            case 61: jj_3_62(); break;
            case 62: jj_3_63(); break;
            case 63: jj_3_64(); break;
            case 64: jj_3_65(); break;
            case 65: jj_3_66(); break;
            case 66: jj_3_67(); break;
            case 67: jj_3_68(); break;
            case 68: jj_3_69(); break;
            case 69: jj_3_70(); break;
            case 70: jj_3_71(); break;
            case 71: jj_3_72(); break;
            case 72: jj_3_73(); break;
            case 73: jj_3_74(); break;
            case 74: jj_3_75(); break;
            case 75: jj_3_76(); break;
            case 76: jj_3_77(); break;
            case 77: jj_3_78(); break;
            case 78: jj_3_79(); break;
            case 79: jj_3_80(); break;
            case 80: jj_3_81(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
