package parsers.CPA;

public class CellDiffusionNode extends CellSecretionNode {
	private double concentration;
	private double rate = 1.0;

	public CellDiffusionNode(String p_chem, double p_conc, double p_rate) {
		super(p_chem);
		rate = p_rate;
		concentration = p_conc;
	}

	public CellDiffusionNode(CellDiffusionNode ce) {
		super(ce);
		chemical = ce.chemical;
		rate = ce.rate;
		concentration = ce.concentration;
	}

	public String getChemical() {
		return chemical;
	}

	public double getConcentration() {
		return concentration;
	}

	public double getRate() {
		return rate;
	}

/*	public String toString() {
		return "diffuses ("
			+ chemical.toString()
			+ ", "
			+ concentration
			+ ", "
			+ rate
			+ ")";
	}
*/	
	public String toString() {
		return "("
			+ chemical.toString()
			+ ", "
			+ concentration
			+ ")";
	}
}
