package parsers.CPA;

public class CellEmissionNode extends CellSecretionNode {
	private Term concentration;
	private DirectionNode direction;

	public CellEmissionNode(
		String p_chem,
		Term p_conc,
		DirectionNode p_direction) {
		super (p_chem);
		concentration = p_conc;
		direction = p_direction;
	}

	public CellEmissionNode (CellEmissionNode ce) {
		super (ce);
		concentration = ce.concentration;
		direction = ce.getDirection();
	}

	public Term getConcentration() {
		return concentration;
	}
	public DirectionNode getDirection() {
		return direction;
	}

	public String toString() {
		String res = "("
					+ chemical.toString()
				 	+ ", "					
					+ concentration
					+ ")";
					
		if (direction != null) {
			res += " in " + direction;
		}
		
		return res;
	}

	public boolean hasDirection() {
		return direction != null;
	}
}
