package parsers.CPA;

import java.util.*;
import simulator.Bindings;

public class ChemicalConditionList {
	private Vector rep;

	public ChemicalConditionList() {
		rep = new Vector();
	}

	public void add(ChemicalCondition conc) {
		rep.addElement(conc);
	}

	public Vector getList() { // exposes rep
		return rep;
	}

	public String toString() {
		StringBuffer retVal = new StringBuffer("");
		int numChemConc = rep.size();

		for (int i = 0; i < numChemConc; i++) {
			if (i == numChemConc - 1)
				retVal.append(rep.elementAt(i).toString());
			else
				retVal.append(
					rep.elementAt(i).toString() + " & ");
		}
		return retVal.toString();
	}

	public int size() {
		return rep.size();
	}

	public Bindings getVariables() {
		Bindings bindings = new Bindings ();
		
		for (Enumeration conds = rep.elements(); conds.hasMoreElements(); ) {
			ChemicalCondition cond = (ChemicalCondition) conds.nextElement();			
			Bindings cbindings = cond.getVariables ();
			bindings.addAll(cbindings);
		}
		
		return bindings;
	}
}
