/*
 * Created on Jun 26, 2003
 */
package parsers.CPA;

import simulator.Bindings;
import simulator.Cell;
import util.Assert;
import util.Direction;
import util.InvalidDirectionException;
import util.Report;

/**
 * @author David Evans
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ChemicalTerm extends Term {
	private String chemical;
	private DirectionNode dir;

	public ChemicalTerm(String p_chemical, DirectionNode p_dir) {
		chemical = p_chemical;
		dir = p_dir;
	}

	public Direction evalDir (Cell c, Bindings bindings) {
		Direction d = (Direction) bindings.lookup(chemical);
		return d;
	}
	
	public double eval(Cell c, Bindings bindings) throws InvalidDirectionException {
		Report.message ("Eval chemical: " + chemical + " in " + dir);
		
		if (c.hasVariable (chemical)) {
			return c.getVariableValue (chemical);
		}
		
		if (dir != null) {
			Direction direct = dir.eval(bindings);
			return c.lookupSensedConcentration(chemical, direct);
		} else {
			return c.lookupSensedConcentration(chemical);
		}
	}

	public String toString() {
//		return "<chem: " + chemical + ">" +  chemical + " in " + dir;
		if (dir != null) return chemical + " from " + dir;
		return chemical;
	}

	public Bindings getVariables() {
		if (dir != null) {
			return dir.getVariables();
		} else {
			return null;

		}
	}
}
