/*
 * Created on Jul 1, 2003
 */
package parsers.CPA;

import simulator.Bindings;
import util.Assert;
import util.Direction;
import util.InvalidDirectionException;

/**
 * @author evans
 */
public class DerivedDirection extends DirectionNode {
	public static final int OPPOSITE = 1;
	public static final int PERPENDICULAR = 2;
	
	private int kind;
	private DirectionNode dir;
	
	public DerivedDirection (int p_kind, DirectionNode p_dir) {
		kind = p_kind;
		dir = p_dir;		
	}
	
	public Direction eval (Bindings bindings) {
		Direction idir;
		
		try {
			idir = dir.eval (bindings);
		} catch (InvalidDirectionException ide) {
			Assert.badBranch ("Invalid direction: " + ide);
			return null;
		}
		
		switch (kind) {
			case OPPOSITE: 
				idir = idir.getOpposite();
				break;
			default:
				Assert.badBranch ("Kind not matched!");
			}

		return idir;		
	}

	public String toString () {
		String res = "";
			
		if (kind == OPPOSITE) {
			res = "opposite(";
		} else {
			Assert.badBranch ("Kind not matched!");
		}
		
		res += dir.toString () + ")";
		return res;
	}
}
