/*
 * Created on Jun 26, 2003
 */
package parsers.CPA;

import simulator.Bindings;
import simulator.Cell;
import util.Assert;
import util.Direction;
import util.InvalidDirectionException;

/**
 * @author David Evans
 */

public class DirectionTerm extends Term {
	private DirectionNode dir;
	
	public DirectionTerm (DirectionNode p_dir) {
		super ();
		dir = p_dir;
	}
	
	public double eval (Cell c, Bindings b) {
		Assert.badBranch ("DirectionTerm cannot be evaluated!");
		return 0.0;
	}
	
	public Direction evalDir (Cell c, Bindings b) throws InvalidDirectionException {
		return dir.eval(b);
	}
	
	public String toString () {
		return /* "<dir: " +  dir + ">" */ dir.toString();
	}
	
	public DirectionNode getNode() {
		return dir;
	}
}
