/*
 * Created on Jul 13, 2003
 */
package parsers.CPA;

import simulator.Bindings;
import simulator.Cell;
import util.Assert;
import util.Direction;
import util.InvalidDirectionException;

/**
 * @author David Evans
 */

public class GoalTerm extends Term {
	private Term term;
	private Token minmax;
		
	public GoalTerm (Token p_minmax, Term p_term) {
		Assert.check (p_minmax.kind == CPAParserConstants.MINIMIZE
					  || p_minmax.kind == CPAParserConstants.MAXIMIZE);
		minmax = p_minmax;
		term = p_term;
	}

	public double eval(Cell c, Bindings bindings) throws InvalidDirectionException {
		return term.eval (c, bindings);
	}

	public Direction evalDir(Cell cell, Bindings bindings) throws InvalidDirectionException {
		return term.evalDir (cell, bindings);
	}

	public Bindings getVariables() {
		return term.getVariables ();
	}
		
	public String toString () {
		return minmax.image + " " + term;
	}

	public boolean isMinimize() {
		return minmax.kind == CPAParserConstants.MINIMIZE;
	}
	
	public boolean isMaximize() {
		return minmax.kind == CPAParserConstants.MAXIMIZE;
	}	
	
}
