/*
 * Created on Jul 1, 2003
 */
package simulator;

import util.Direction;

/**
 * @author evans
 */
public class CellEmission extends CellSecretion {
	private Direction direction;

	public CellEmission(String p_chem, double p_conc, Direction p_direction) {
		super (p_chem, p_conc);
		direction = p_direction;
	}

	public CellEmission(CellEmission ce) {
		super (ce);
		direction = ce.direction;
	}

	public Direction getDirection() {
		return direction;
	}

	public String toString() {
		String res = "emits (" + getChemical () + ": " + getConcentration () + ")";
		
		if (direction != null) {
			res += " in " + direction;			
		}
		
		return res;
	}

	/**
	 * @param absoluteDirection
	 */
	public void setDirection(Direction p_direction) {
		direction = p_direction;
	}
}
