package simulator;

import java.util.*;

import parsers.CPA.ChemicalDescription;
import util.*;

abstract public class CellProgram {
	public abstract void init(Vector args);
	public abstract void runCellProgramForOneStep(Cell cell);
	public abstract void extend(CellProgram cpa);
	public abstract FColor getColor (Cell cell);
	public abstract Vector getEmissions (Cell cell);
	public abstract Vector getDiffusions (Cell cell);
	//public abstract String getFirstState();
	public abstract Vector getFirstStates();
	public abstract ChemicalDescription getChemical(String chem);
}
