package simulator;

import java.util.*;

class StatsRecord {
	String key;
	long value;

	public StatsRecord(String p_key, long p_value) {
		key = p_key;
		value = p_value;
	}
}

public class StatsTable {
	// A string-long mapping.  Simple linear search is fine.
	Vector stats;

	public StatsTable() {
		stats = new Vector();
	}

	public int size() {
		return stats.size();
	}

	public String getKey(int i) {
		return ((StatsRecord) stats.elementAt(i)).key;
	}

	public long getValue(int i) {
		return ((StatsRecord) stats.elementAt(i)).value;
	}

	public void setValue(String key, long value) {
		// effects If key already exists, update its value to value.  If not, add key and value.
		for (Enumeration e = stats.elements(); e.hasMoreElements();) {
			StatsRecord el = (StatsRecord) e.nextElement();

			if (el.key.equals(key)) {
				el.value = value;
				return;
			}
		}

		stats.add(new StatsRecord(key, value));
	}

	public Enumeration keys() {
		Vector keys = new Vector();
		for (Enumeration e = stats.elements(); e.hasMoreElements();) {
			StatsRecord el = (StatsRecord) e.nextElement();
			keys.add(el.key);
		}
		return keys.elements();
	}

	public Enumeration values() {
		Vector values = new Vector();
		for (Enumeration e = stats.elements(); e.hasMoreElements();) {
			StatsRecord el = (StatsRecord) e.nextElement();
			values.add(new Long(el.value));
		}
		return values.elements();
	}

	public String toString() {
		String res = "";

		for (Enumeration e = stats.elements(); e.hasMoreElements();) {
			StatsRecord el = (StatsRecord) e.nextElement();
			res += el.key + ": " + el.value + "\n";
		}

		return res;
	}

	public String toCSVString() {
		String res = "";

		for (Enumeration e = stats.elements(); e.hasMoreElements();) {
			StatsRecord el = (StatsRecord) e.nextElement();
			res += el.value + ",";
		}

		res += "\n";
		return res;
	}
}
