package sysmodels;

import util.*;

// CellDifussion is one object in vector CellDiffusionList used in env, 
// when resolveDiffusion, env will calculate the conc based, on the CellDiffusionlist
// in all the previous models, CellEmission is used as a datatype that represents bothe CellEmission and CellDiffusion
// now, CellEmission and CellDiffusion are seperate datatypes, they are interchangeable, however, CellDiffusion
// has no use of direction and operation because diffusion is in all direction.
public class CellDiffusion {
	double x;
	double y;
	double z;
	String chemical;
	String operator;
	double concentration;
	Direction direction;
	double factor;
	//CellEmission ce;// the CellEmission corresponds to the point (x,y,z)

	public CellDiffusion(
		double X,
		double Y,
		double Z,
		String p_chem,
		double p_factor) {
		x = X;
		y = Y;
		z = Z;
		chemical = p_chem;
		concentration = 0.0;
		operator = null;
		direction = Direction.UNDEFINED;
		factor = p_factor;
	}

	public CellDiffusion(int X, int Y, int Z, String p_chem, int p_factor) {
		x = (double) X;
		y = (double) Y;
		z = (double) Z;
		chemical = p_chem;
		concentration = 0.0;
		operator = null;
		direction = Direction.UNDEFINED;
		factor = p_factor;
	}
	/*CellDiffusion(double X, double Y, double Z,String p_chem, double p_factor){
		 x=X;y=Y;z=Z;
		ce=new CellEmission(p_chem);
		factor = p_factor;
	}*/

	public CellDiffusion(CellDiffusion cd) {
		x = cd.getX();
		y = cd.getY();
		z = cd.getZ();
		chemical = cd.getChemical();
		operator = cd.getOperator();
		concentration = cd.getConcentration();
		direction = cd.getDirection();
		factor = cd.getFactor();
	}

	/*CellDiffusion(double X, double Y, double Z, CellEmission ce, double p_factor){
		x=X;y=Y;z=Z;
		ce=new CellEmission(ce);
		factor = p_factor;
	}*/

	public CellDiffusion(
		double X,
		double Y,
		double Z,
		String p_chem,
		String p_operator,
		double p_conc,
		Direction p_direction,
		double p_factor) {
		x = X;
		y = Y;
		z = Z;
		chemical = p_chem;
		operator = p_operator;
		concentration = p_conc;
		direction = p_direction;
		factor = p_factor;
	}
	public CellDiffusion(
		int X,
		int Y,
		int Z,
		String p_chem,
		String p_operator,
		double p_conc,
		Direction p_direction,
		double p_factor) {
		x = (double) X;
		y = (double) Y;
		z = (double) Z;
		chemical = p_chem;
		operator = p_operator;
		concentration = p_conc;
		direction = p_direction;
		factor = p_factor;
	}
	/*CellDiffusion (double X, double Y, double Z, String p_chem, String p_operator, double p_conc, Direction p_direction, double p_factor)
	{ x=X;y=Y;z=Z;
	ce=new CellEmission(p_chem,p_operator,p_conc,p_direction);
	factor = p_factor;}*/

	public CellDiffusion(
		double X,
		double Y,
		double Z,
		String p_chem,
		double p_conc,
		Direction p_direction,
		double p_factor) {
		x = X;
		y = Y;
		z = Z;
		chemical = p_chem;
		operator = null;
		concentration = p_conc;
		direction = p_direction;
		factor = p_factor;
	}

	CellDiffusion(
		int X,
		int Y,
		int Z,
		String p_chem,
		double p_conc,
		Direction p_direction,
		double p_factor) {
		x = (double) X;
		y = (double) Y;
		z = (double) Z;
		chemical = p_chem;
		operator = null;
		concentration = p_conc;
		direction = p_direction;
		factor = p_factor;
	}

	/*CellDiffusion (double X, double Y, double Z, String p_chem,double p_conc, Direction p_direction, double p_factor)
	{  x=X;y=Y;z=Z;
	ce=new CellEmission(p_chem,p_conc,p_direction);
	factor = p_factor;}*/

	public double getX() {
		return x;
	}
	public double getY() {
		return y;
	}
	public double getZ() {
		return z;
	}
	//public CellEmission getCellEmission(){return ce;}

	public void setX(double X) {
		x = X;
	}

	public void setY(double Y) {
		y = Y;
	}
	public void setZ(double Z) {
		z = Z;
	}
	//public void setCellEmission(CellEmission ce){ce=new CellEmission(ce);}

	public String getChemical() {
		return new String(chemical);
	}
	public String getOperator() {
		return operator;
	}
	double getConcentration() {
		return concentration;
	}
	public Direction getDirection() {
		return direction;
	}

	public double getFactor() {
		return factor;
	}

	public void setChemical(String p_chem) {
		chemical = p_chem;
	}
	public void setOperator(String p_oper) {
		operator = p_oper;
	}
	public void setConcentration(double p_conc) {
		concentration = p_conc;
	}
	public void setDirection(Direction p_dir) {
		direction = p_dir;
	}

	public void setFactor(double p_factor) {
		factor = p_factor;
	}

	public String toString() {
		if (direction != null) {
			if (operator != null) {
				return "("
					+ chemical.toString()
					+ operator
					+ concentration
					+ ")";
			} else {
				return "(" + chemical.toString() + "," + concentration + ")";
			}
		} else {
			if (operator != null) {
				return "("
					+ chemical.toString()
					+ operator
					+ concentration
					+ ")";
			} else {
				return "(" + chemical.toString() + "," + concentration + ")";
			}
		}
	}
}
