/*
 * Created on Jun 18, 2003
 */
package util;

/**
 * @author David Evans
 */
public class Report {
	static private int level = 0;

	public static void setReportLevel(int p_level) {
		level = p_level;
	}

	public static void message(String s) {
		if (level > 1) {
			System.out.flush();
			System.out.println(s);
		}
	}

	public static void message(int i, String s) {
		if (level >= i) {
			System.out.flush();
			System.out.println(s);
			System.out.flush();
		}		
	}

	public static void fatalError(String s) {
		System.out.println("FATAL ERROR! " + s); 
		System.err.println(s);
		Assert.showStack();
		System.exit(-1);

	}

	public static void display(String s) {
		System.err.println(s);
	}

	public static void nonFatalError(String s) {
		display(s);
	}

	public static String showArray(double[] arr) {
		if (arr == null) {
			return "[<null>]";
		} else {

			String res = "[";

			for (int i = 0; i < arr.length; i++) {
				if (i != 0) {
					res += ", ";
				}

				res += arr[i];
			}

			return res + "]";
		}
	}

	public static String showMatrix(double[][] arr) {
		if (arr == null) {
			return "[<null>]";
		} else {

			String res = "[";

			for (int i = 0; i < arr.length; i++) {
				if (i != 0) {
					res += ", ";
				}

				res += showArray(arr[i]);
			}

			return res + "]";
		}
	}

	public static void warning(boolean b, String s) {
		if (b) display (s);
	}
}
